/*
 * serverConnection.java
 *
 * Created on tvrtok, 2007, december 6, 13:03
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package generatory;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.ServerSocket;
import java.net.Socket;
import java.net.SocketException;

/**
 *
 * @author Ti bo
 */
public class serverConnection {
    public String strAcc="", strSur="", strName="", strType="", strCount="", strPort="";
    public String[] students, subjects;
    /** Creates a new instance of serverConnection */
    public serverConnection() throws IOException {
            
            
    }

    public boolean spracuj(Socket client) throws SocketException{
        InputStream in;
        InputStreamReader isr;
        BufferedReader br;
        try {
            in = client.getInputStream();
            isr = new InputStreamReader(in);
            br = new BufferedReader(isr);
            return readMessage(br);
        } catch (IOException ex) {
            ex.printStackTrace();
        }
       return false;
    }
    
    public boolean read() throws IOException{
        //if (!Client.ss.isClosed()) {
            
            return spracuj(Client.ss.accept());
        //}
       
       // return true;
    }

    public boolean readSL() throws IOException{
        Client.ss.accept();
        return true;
    }
    
    public void close(){
        try {
            if ((Client.ss.isClosed())==false) {
                Client.ss.close();
            }
        } catch (IOException ex) {
            ex.printStackTrace();
        }
    }

    private boolean readMessage(BufferedReader br) throws IOException {
        String line;
        line=br.readLine();
        // volanie jednotlivych funkcii (podla toho aka odpoved pride zo servera)
        while (line != "") {
            if (line.indexOf("<login_answ>")>-1){
                return vypisLoginInfo(br);   
            }
            if (line.indexOf("<studList_answ>")>-1){
                return vypisZozStud(br);
            }
            if (line.indexOf("<subjList_answ>")>-1){
                return vypisZozPredmetov(br);
            }
            line=br.readLine();
        }
        return false;
    }

    private boolean vypisLoginInfo(BufferedReader br) throws IOException {
        String line;
        
        line=br.readLine();
        while (line != null && line.indexOf("</login_answ>")<0) {
            if (line.indexOf("<access>")>-1){
                strAcc = line.substring(line.indexOf("<access>")+new String ("<access>").length(), line.indexOf("</access>"));
            }
            
            if (line.indexOf("<name>")>-1){
                strName = line.substring(line.indexOf("<name>")+new String ("<name>").length(), line.indexOf("</name>"));
            }
            
            if (line.indexOf("<surname>")>-1){
                strSur = line.substring(line.indexOf("<surname>")+new String ("<surname>").length(), line.indexOf("</surname>"));
            }
            
            if (line.indexOf("<type>")>-1){
                strType = line.substring(line.indexOf("<type>")+new String ("<type>").length(), line.indexOf("</type>"));
            }
            
            if (line.indexOf("<serverPort>")>-1){
                strPort = line.substring(line.indexOf("<serverPort>")+new String ("<serverPort>").length(), line.indexOf("</serverPort>"));
            }
            line=br.readLine();
        }
        if (strAcc.compareTo("success")==0) {
            return true;
        } else {
            return false;
        }
    }

    private boolean vypisZozStud(BufferedReader br) throws IOException {
        String line,meno,priezvisko;
        int i=0;
        
        
        line=br.readLine();
        while (line != null && line.indexOf("</studList_answ>")<0) {
            if (line.indexOf("<count>")>-1){
                strCount = line.substring(line.indexOf("<count>")+new String ("<count>").length(), line.indexOf("</count>"));
                students = new String[new Integer(strCount).intValue()];
            }
            if (line.indexOf("<student>")>-1){
                line = br.readLine();
                meno = line.substring(line.indexOf("<name>")+new String ("<name>").length(), line.indexOf("</name>"));
                line = br.readLine();
                priezvisko = line.substring(line.indexOf("<surname>")+new String ("<surname>").length(), line.indexOf("</surname>"));
                students[i]=new String(meno+","+priezvisko);
                i++;
            }
            line=br.readLine();
        }
        return true;
    }
    
    private boolean vypisZozPredmetov(BufferedReader br) throws IOException {
        String line,nazov;
        int i=0;
        
        line=br.readLine();
        while (line != null && line.indexOf("</subjList_answ>")<0) {
            if (line.indexOf("<count>")>-1){
                strCount = line.substring(line.indexOf("<count>")+new String ("<count>").length(), line.indexOf("</count>"));
                subjects = new String[new Integer(strCount).intValue()];
            }
            if (line.indexOf("<subject>")>-1){
                line = br.readLine();
                nazov = line.substring(line.indexOf("<name>")+new String ("<name>").length(), line.indexOf("</name>"));
                // moznost pridania dalsich informacii o predmete
                subjects[i]=new String(nazov);
                i++;
            }
            line=br.readLine();
        }
        return true;
    }
    
    public int changePort() {
        return new Integer(strPort).intValue();
    }
}
